function p = imm_kpca_preimg_honeine(p)

% Implementation of pre-image algorithm presented in:
%    Honeine, P.; Richard, C., "Solving the pre-image problem in kernel
%    machines: A direct method", Machine Learning for Signal Processing,
%    2009. MLSP 2009. IEEE International Workshop on.

% variables
lam   = 0.1;

K_test  = p.K_test;
X_test  = p.X_test;
X_train = p.X_train;

K = p.K;
H = p.H;
M = p.M;
N = p.N;
One = p.One;

% input space distance
P = imm_kpca_euclidean_dist(X_train',X_train');

inv_K = pinv(K);
inv_P = pinv(P);

N_test = size(X_test,2);

for n=1:N_test
    
    k     = K_test(:,n);
    kx_c  = H*(k - K*One);
    gamma =  kx_c' * M;
    gamma_hat = gamma + (1 - sum(gamma))/N;
    
    p.X_preimg(:,n) = X_train*inv_P*(P-lam*inv_K)*gamma_hat';
end
